{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        init : function(){
            var t = this;
            t.gridLoaded=false;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            t.windowButtons.formCancel=false;
            t.stores.status=new mj.store({
                data:[{id:'OPEN',code:"{{ 'OperationAuthorization.statusopen'|trans }}"}
                    ,{id:'CLOSE',code:"{{ 'OperationAuthorization.statusclose'|trans }}"}
                ]
            });
            const formConfig= {
                items: [
                    new mj.form.combo({
                        title: "{{ 'OperationAuthorization.status'|trans }}",
                        placeHolder: "{{ 'OperationAuthorization.status'|trans }}",
                        dataIndex: 'status',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        sameValueDisplay:false,
                        labelWidth : '110px',
                        grid: 's6 m4',
                        width: 150,
                        store: t.stores.status
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);

            t.forms.main.store.preloaded = true;
            t.forms.main.store.data = t.data.OperationAuthorization.records[0];
            t.forms.main.store.load();
            t.tabPanels.main.setActive(0);
        },
        editSelectedRecord: function(){
            return;
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                t.waitMaskShow();
                var id = 1;
                var version = 1;
                var mode = 'update';
                var routeName = f.modulename + '-' + mode;
                var route = Routing.getRoute(routeName);
                var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                    'pg': t.grids.main.pbar.current,
                    'lm': t.grids.main.pbar.limit
                } : {'pg':1,'lm':25};
                var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                    'id': id,
                    'v': version
                }) : pagerParams);
                var data = f.getValue();
                data.menuId = t.id;
                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    t._event='save';
                    $.ajax({
                        url: url,
                        method: "POST",
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0] 
                        },
                        data: JSON.stringify(data),
                        dataType: 'json',
                        success: function(data, textStatus, xhr) {
                            t.waitMaskHide();
                            if(textStatus==='success'){
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: xhr.responseJSON.message,
                                    type: "success",
                                    html: true
                                });
                            }
                        },
                        error: function(xhr, textStatus, errorThrown) {
                            t.waitMaskHide();
                            if(xhr.responseJSON&&xhr.responseJSON.message){
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: xhr.responseJSON.message,
                                    type: "error",
                                    html: true
                                });
                            }
                        },
                        complete: function(jqXHR, textStatus) {
                            t.waitMaskHide();
                        }
                    });
                }
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
